;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UrForth level 1: self-hosting 32-bit Forth compiler
;; Copyright (C) 2020 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
[IFNDEF] forth:utf
vocabulary utf
[ENDIF]

also utf definitions


create (cp1251->uni)
0x0000 w, 0x0001 w, 0x0002 w, 0x0003 w, 0x0004 w, 0x0005 w, 0x0006 w, 0x0007 w, 0x0008 w, 0x0009 w, 0x000a w, 0x000b w, 0x000c w, 0x000d w, 0x000e w, 0x000f w,
0x0010 w, 0x0011 w, 0x0012 w, 0x0013 w, 0x0014 w, 0x0015 w, 0x0016 w, 0x0017 w, 0x0018 w, 0x0019 w, 0x001a w, 0x001b w, 0x001c w, 0x001d w, 0x001e w, 0x001f w,
0x0020 w, 0x0021 w, 0x0022 w, 0x0023 w, 0x0024 w, 0x0025 w, 0x0026 w, 0x0027 w, 0x0028 w, 0x0029 w, 0x002a w, 0x002b w, 0x002c w, 0x002d w, 0x002e w, 0x002f w,
0x0030 w, 0x0031 w, 0x0032 w, 0x0033 w, 0x0034 w, 0x0035 w, 0x0036 w, 0x0037 w, 0x0038 w, 0x0039 w, 0x003a w, 0x003b w, 0x003c w, 0x003d w, 0x003e w, 0x003f w,
0x0040 w, 0x0041 w, 0x0042 w, 0x0043 w, 0x0044 w, 0x0045 w, 0x0046 w, 0x0047 w, 0x0048 w, 0x0049 w, 0x004a w, 0x004b w, 0x004c w, 0x004d w, 0x004e w, 0x004f w,
0x0050 w, 0x0051 w, 0x0052 w, 0x0053 w, 0x0054 w, 0x0055 w, 0x0056 w, 0x0057 w, 0x0058 w, 0x0059 w, 0x005a w, 0x005b w, 0x005c w, 0x005d w, 0x005e w, 0x005f w,
0x0060 w, 0x0061 w, 0x0062 w, 0x0063 w, 0x0064 w, 0x0065 w, 0x0066 w, 0x0067 w, 0x0068 w, 0x0069 w, 0x006a w, 0x006b w, 0x006c w, 0x006d w, 0x006e w, 0x006f w,
0x0070 w, 0x0071 w, 0x0072 w, 0x0073 w, 0x0074 w, 0x0075 w, 0x0076 w, 0x0077 w, 0x0078 w, 0x0079 w, 0x007a w, 0x007b w, 0x007c w, 0x007d w, 0x007e w, 0x007f w,
0x0402 w, 0x0403 w, 0x201a w, 0x0453 w, 0x201e w, 0x2026 w, 0x2020 w, 0x2021 w, 0x20ac w, 0x2030 w, 0x0409 w, 0x2039 w, 0x040a w, 0x040c w, 0x040b w, 0x040f w,
0x0452 w, 0x2018 w, 0x2019 w, 0x201c w, 0x201d w, 0x2022 w, 0x2013 w, 0x2014 w, 0xfffd w, 0x2122 w, 0x0459 w, 0x203a w, 0x045a w, 0x045c w, 0x045b w, 0x045f w,
0x00a0 w, 0x040e w, 0x045e w, 0x0408 w, 0x00a4 w, 0x0490 w, 0x00a6 w, 0x00a7 w, 0x0401 w, 0x00a9 w, 0x0404 w, 0x00ab w, 0x00ac w, 0x00ad w, 0x00ae w, 0x0407 w,
0x00b0 w, 0x00b1 w, 0x0406 w, 0x0456 w, 0x0491 w, 0x00b5 w, 0x00b6 w, 0x00b7 w, 0x0451 w, 0x2116 w, 0x0454 w, 0x00bb w, 0x0458 w, 0x0405 w, 0x0455 w, 0x0457 w,
0x0410 w, 0x0411 w, 0x0412 w, 0x0413 w, 0x0414 w, 0x0415 w, 0x0416 w, 0x0417 w, 0x0418 w, 0x0419 w, 0x041a w, 0x041b w, 0x041c w, 0x041d w, 0x041e w, 0x041f w,
0x0420 w, 0x0421 w, 0x0422 w, 0x0423 w, 0x0424 w, 0x0425 w, 0x0426 w, 0x0427 w, 0x0428 w, 0x0429 w, 0x042a w, 0x042b w, 0x042c w, 0x042d w, 0x042e w, 0x042f w,
0x0430 w, 0x0431 w, 0x0432 w, 0x0433 w, 0x0434 w, 0x0435 w, 0x0436 w, 0x0437 w, 0x0438 w, 0x0439 w, 0x043a w, 0x043b w, 0x043c w, 0x043d w, 0x043e w, 0x043f w,
0x0440 w, 0x0441 w, 0x0442 w, 0x0443 w, 0x0444 w, 0x0445 w, 0x0446 w, 0x0447 w, 0x0448 w, 0x0449 w, 0x044a w, 0x044b w, 0x044c w, 0x044d w, 0x044e w, 0x044f w,
create;

: cp1251->uni  ( ch -- unich )  0xff and (cp1251->uni) + w@ ;


create (uni->cp1251-ctbl0)
0xa1 c, 0x8f c, 0xc0 c, 0xc1 c, 0xc2 c, 0xc3 c, 0xc4 c, 0xc5 c, 0xc6 c, 0xc7 c, 0xc8 c, 0xc9 c, 0xca c, 0xcb c, 0xcc c, 0xcd c,
0xce c, 0xcf c, 0xd0 c, 0xd1 c, 0xd2 c, 0xd3 c, 0xd4 c, 0xd5 c, 0xd6 c, 0xd7 c, 0xd8 c, 0xd9 c, 0xda c, 0xdb c, 0xdc c, 0xdd c,
0xde c, 0xdf c, 0xe0 c, 0xe1 c, 0xe2 c, 0xe3 c, 0xe4 c, 0xe5 c, 0xe6 c, 0xe7 c, 0xe8 c, 0xe9 c, 0xea c, 0xeb c, 0xec c, 0xed c,
0xee c, 0xef c, 0xf0 c, 0xf1 c, 0xf2 c, 0xf3 c, 0xf4 c, 0xf5 c, 0xf6 c, 0xf7 c, 0xf8 c, 0xf9 c, 0xfa c, 0xfb c, 0xfc c, 0xfd c,
0xfe c, 0xff c,
create;

create (uni->cp1251-ctbl1)
0xa8 c, 0x80 c, 0x81 c, 0xaa c, 0xbd c, 0xb2 c, 0xaf c, 0xa3 c, 0x8a c, 0x8c c, 0x8e c, 0x8d c,
create;

create (uni->cp1251-ctbl2)
0xb8 c, 0x90 c, 0x83 c, 0xba c, 0xbe c, 0xb3 c, 0xbf c, 0xbc c, 0x9a c, 0x9c c, 0x9e c, 0x9d c,
create;

create (uni->cp1251-ctbl3)
0xab c, 0xac c, 0xad c, 0xae c,
create;

: uni->cp1251  ( unich -- ch )
  dup case
    128 u<of 0xff and endof
    0x040e 0x044f bounds-of 0x040e - (uni->cp1251-ctbl0) + c@ endof
    0x0401 0x040c bounds-of 0x0401 - (uni->cp1251-ctbl1) + c@ endof
    0x0451 0x045c bounds-of 0x0451 - (uni->cp1251-ctbl2) + c@ endof
    0x00a0 of 0xa0 endof
    0x00a4 of 0xa4 endof
    0x00a6 of 0xa6 endof
    0x00a7 of 0xa7 endof
    0x00a9 of 0xa9 endof
    0x00b0 of 0xb0 endof
    0x00b1 of 0xb1 endof
    0x00b5 of 0xb5 endof
    0x00b6 of 0xb6 endof
    0x00b7 of 0xb7 endof
    0x00bb of 0xbb endof
    0x045e of 0xa2 endof
    0x045f of 0x9f endof
    0x0490 of 0xa5 endof
    0x0491 of 0xb4 endof
    0x2013 of 0x96 endof
    0x2014 of 0x97 endof
    0x2018 of 0x91 endof
    0x2019 of 0x92 endof
    0x201a of 0x82 endof
    0x201c of 0x93 endof
    0x201d of 0x94 endof
    0x201e of 0x84 endof
    0x2020 of 0x86 endof
    0x2021 of 0x87 endof
    0x2022 of 0x95 endof
    0x2026 of 0x85 endof
    0x2030 of 0x89 endof
    0x2039 of 0x8b endof
    0x203a of 0x9b endof
    0x20ac of 0x88 endof
    0x2116 of 0xb9 endof
    0x2122 of 0x99 endof
    ;;0xfffd of 0x98 endof
    0x00ab 0x00ae bounds-of 0x00ab - (uni->cp1251-ctbl3) + c@ endof
    otherwise 2drop [char] ?
  endcase
;


previous definitions
